#include <iostream>
#include <string>
#include <typeinfo>
using namespace std;

template <typename T>
class Thing
{
private:
    T x;
public:
    Thing();
    Thing(T);
    Thing(const Thing<T>&);
    T get() const;
    operator T() const;
};

template <typename T>
Thing<T>::Thing() : x(0) {}

template <typename T>
Thing<T>::Thing(T n) : x(n) {}

template <typename T>
Thing<T>::Thing(const Thing<T>& t) : x(t.x) {}

template <typename T>
T Thing<T>::get() const
{
    return x;
}

template <typename T>
Thing<T>::operator T() const
{
    return x;
}

template <typename T>
ostream& operator<<(ostream& s, const Thing<T>& t)
{
    return s << t.get();
}

int main(void)
{
    Thing<int> t1;
    cout << "t1=" << t1 << endl;

    Thing<int> t2(18);
    cout << "t2=" << t2 << endl;

    Thing<double> t3(1.28);
    cout << "t3=" << t3 << endl;

    Thing<double> t4(t3);
    cout << "t4=" << t4 << endl;

    cout << "(t2.get() + t3.get()) = " << (t2.get() + t3.get()) << endl;
    cout << "t2 + t3 = " << t2 + t3 << endl;

    Thing<char> t5('z');
    cout << "t5=" << t5 << endl;

    Thing<string> t6("howdy");
    cout << "t6=" << t6 << endl;

    cout << t6.get()[2] << endl;
}
